package jalview.rest;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jalview.bin.Cache;
import jalview.gui.Desktop;
import jalview.gui.SequenceFetcher;
import jalview.util.DBRefUtils;

public class FetchSequencesEndpoint extends AbstractEndpointAsync
{
  public FetchSequencesEndpoint(API api)
  {
    super(api, path, name, parameters, description);
  }

  private static final String path = "fetchsequences";

  private static final String name = "Fetch Sequences";

  private static final String parameters = "<resource name>,<sequence ids>";

  private static final String description = "Fetch sequences from online resource";

  private SequenceFetcher sf;

  @Override
  protected void initialise(HttpServletRequest request,
          HttpServletResponse response)
  {
    if (!checkParameters(request, response, 2))
    {
      return;
    }
    String[] parameters = getEndpointPathParameters(request);

    String dbName = parameters[0];
    String dbId = parameters[1];

    setId(request, dbName + "::" + dbId);
    if (checkStatus(request, response))
      return;

    String db = DBRefUtils.getCanonicalName(dbName);
    Desktop desktop = Desktop.instance;
    sf = new SequenceFetcher(desktop, db, dbId);
    setCompletableFuture(sf.ok_actionPerformed(true));
  }

  protected void processAsync(HttpServletRequest request,
          HttpServletResponse response, Map<String, String> map)
  {
    // all the work being done by the SequenceFetcher!
    Cache.warn("THIS SHOULD NOT BE RUN");
  }

  protected void atEnd()
  {
    sf.close_actionPerformed(null);
  }
}
